attribute vec3 tangent;
varying vec3 EyeVector;
varying vec3 LightVector;

void main(void)
{
	gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	gl_Position    = ftransform();

    vec3 n = normalize(gl_NormalMatrix * gl_Normal);
    vec3 t = normalize(gl_NormalMatrix * tangent);
    vec3 b = cross(n, t);
	mat3 tbn = mat3(t,b,n);

    vec3 eyeDir = -(gl_ModelViewMatrix * gl_Vertex).xyz;
	EyeVector = eyeDir * tbn;
	
    vec3  lightDir = gl_LightSource[0].position.xyz + eyeDir;
    LightVector = lightDir * tbn;
}
