varying vec4 projCoord;
varying vec3 Normal;
varying vec3 Light;
varying vec3 HalfVector;
varying vec3 reflDir;

mat3 getLinearPart(mat4 m)
{
	mat3 result;
	
	result[0][0] = m[0][0]; 
	result[0][1] = m[0][1]; 
	result[0][2] = m[0][2]; 

	result[1][0] = m[1][0]; 
	result[1][1] = m[1][1]; 
	result[1][2] = m[1][2]; 
	
	result[2][0] = m[2][0]; 
	result[2][1] = m[2][1]; 
	result[2][2] = m[2][2]; 
	
	return result;
}

void main()
{
	gl_TexCoord[0] = gl_MultiTexCoord0;
	
	Normal = normalize(gl_NormalMatrix * gl_Normal);
	
	vec4 realPos = gl_ModelViewMatrix * gl_Vertex;
	Light = normalize(vec3(gl_LightSource[0].position-realPos));
	
	HalfVector = normalize(gl_LightSource[0].halfVector.xyz);
	
	projCoord = gl_TextureMatrix[1] * realPos;
	
	vec3 normalVec = normalize(getLinearPart(gl_TextureMatrix[2]) * gl_NormalMatrix * gl_Normal);
	vec3 cameraPos = gl_TextureMatrix[2][3].xyz;
	vec3 cameraVec = (gl_TextureMatrix[2] * realPos).xyz - cameraPos;
	reflDir = reflect(cameraVec, normalVec);

	gl_Position = ftransform();
}
